<template>
  <div class="project-cards">
    <template v-if="projects.length > 0">
      <div v-for="project in projects" :key="project.id">
        <project-item
          :project="project"
          @update="updateProject"
          @delete="deleteProject(project)"
        />
      </div>
    </template>
  </div>

  <prime-dialog
    v-model:visible="isEditModalOpen"
    header="Создать новый проект"
    :modal="true"
  >
    <edit-project
      @close="isEditModalOpen = false"
      @create="createProject"
    />
  </prime-dialog>
</template>

<script lang="ts">
import PrimeDialog from 'primevue/dialog/Dialog.vue';
import { defineComponent, PropType } from 'vue';
import EditProject from '@/components/projects/EditProject.vue';
import ProjectItem from '@/components/projects/Project.vue';
import { Project, ProjectExtended } from '@/models/projects';

interface Data {
  isEditModalOpen: boolean;
}

export default defineComponent({
  name: 'project-list',
  components: {
    PrimeDialog,

    EditProject,
    ProjectItem,
  },
  props: {
    isShared: { type: Boolean, required: true },
    projects: { type: Array as PropType<ProjectExtended[]>, required: true },
  },
  emits: ['update_project', 'delete_project'],
  data(): Data {
    return {
      isEditModalOpen: false,
    };
  },
  methods: {
    updateProject(updatedProject: Project): void {
      this.$emit('update_project', updatedProject);
    },
    deleteProject(deletedProject: ProjectExtended) {
      this.$emit('delete_project', deletedProject);

    },
    // createProject(project: ProjectExtended): void {
    //   this.projects.push(project);
    // },
  },
});
</script>

<style lang="scss" scoped>
.project-cards {
  display: flex;
  flex-wrap: wrap;

  & > * {
    margin-bottom: 2rem;

    &:not(:last-child) {
      margin-right: 2rem;
    }
  }
}
</style>
